;Copywrite 2001 Samuel Stearley

	include	"os.h"
	xdef		_nostub
	xdef		_ti89


debug MACRO
	move #1,ccr
loops:	bcs loops
 ENDM


;---INSTALL MY EVENT HOOK----

	movem.l	d3-d7/a2-a6,-(a7)
	move.l	a7,d7				;save stack pointer
	move.l	200,a6			;pointer to the jump table

;---Write in the program to execute which is passed as a parameter-----


	move.l	1060(a6),a0			;pointer to top of estack pointer
	move.l	(a0),a1			;now get top of estack pointer
	pea		string_error_msg(pc)
	cmp.b		#$2D,(a1)			;is it a string?
	bne		display_error		;if not end it
	lea		end_of_name(pc),a0	;place to copy to
	subq.l	#1,a1				;point to end zero of the string
	moveq		#17,d0			;17 character maximum
copy_name_loop:
	move.b	-(a1),-(a0)			;copy it
	dbeq		d0,copy_name_loop		;go until 8 bytes copied or the zero is hit
	bne		display_error		;If it did not hit the zero then an error occured
	
;---Get the key code--------------------

	pea		key_code_error(pc)
	cmp.b		#$1f,-(a1)			;check the tag
	bne		display_error
	move.b	-(a1),d0			;get the size of the positive interger
	beq		display_error
	cmp.b		#3,d0				;is it 3 or above?
	bcc		display_error
	moveq		#0,d1
	move.b	-(a1),d1			;get the first part of it
	subq.b	#1,d0
	beq.s		no_more
	lsl.w		#8,d1				;move it up
	move.b	-(a1),d1			;get the next part
no_more:
	lea		compare_opcode+2(pc),a0	;pointer to the opcode
	move.w	d1,(a0)

;---Get the flag to test if there is a flag---------------------

	pea		modifier_error(pc)
	lea		branch_opcode+2(pc),a2
	move.w	#2,(a2)			;skip the branch
	cmp.b		#$E5,-(a1)			;is there a flag?
	bne.s		check_for_argument
	move.w	#jump_end-jump_start+2,(a2)
	bra.s		install_tsr


;---The following code is for a flag | if there was a flag---------------

check_for_argument:
	cmp.b		#$2D,(a1)			;is there a flag?
	bne.s		display_error		;guess not
	subq.l	#2,a1				;point to the char

;---check which modifier it is----

	lea		bit_test+2(pc),a0
	cmp.b		#'2',(a1)			;is it the second
	bne.s		not_second
	move.w	#0,(a0)
	bra.s		install_tsr
not_second:
	cmp.b		#'a',(a1)			;is it the alpha
	bne.s		not_alpha
	move.w	#3,(a0)
	bra.s		install_tsr
not_alpha:
	cmp.b		#'s',(a1)			;is it shift?
	bne.s		not_shift
	move.w	#1,(a0)
	bra.s		install_tsr
not_shift:
	cmp.b		#'d',(a1)			;is it the diamond?----------
	bne.s		display_error
	move.w	#2,(a0)

install_tsr:

;---Now to relocate the tsr into high ram-----

	move.l	2700(a6),a5			;got pointer to old evhook
	lea		old_event(pc),a1		;get pointer to the save space
	move.l	(a5),(a1)			;save it
	move.l	#END_OF_HOOK-BEGINNING_OF_HOOK,d3	;amount of ram needed
	move.l	d3,-(a7)			;ram needed to copy code too
	move.l	584(a6),a0			;get heap allocate high call
	jsr		(a0)				;allocate it -d0 has the handle
	pea		error_message(pc)
	tst.w		d0				;check for success
	beq		display_error
	move.w	d0,-(a7)			;push for dereferencing
	move.l	600(a6),a0			;get dereference call -ao points to allocated memory
	jsr		(a0)
	move.l	a0,a1
	add.l		#$40010,a0			;increase the first to bypass hw2 protection
	move.l	a0,(a5)			;overwrite old event handler
	subq.l	#1,d3				;for dbra
	lea		BEGINNING_OF_HOOK(pc),a0
copy_loop:
	move.b	(a0)+,(a1)+
	dbra		d3,copy_loop		;copy over the handler
	pea		message(pc)
display_error:
	move.l	920(a6),a0			;help displag call
	jsr		(a0)

;---Restore Registers and exit the installation-----

final:
	move.l	d7,a7				;reset the stack
	movem.l	(a7)+,d3-d7/a2-a6		;get registers back
	rts

;-----STRINGS-------

modifier_error:	dc.b	"No modifier was specified",0
string_error_msg:	dc.b	"The string is invalid",0
error_message:	dc.b	"Not enough memory",0
message		dc.b	"ShortCut by Samuel Stearley (c) 2001",0
key_code_error:	dc.b	"The keycode is invalid",0


	EVEN		


;---------------------------------------------------------
;AND NOW FOR THE CODE OF THE SHIFT ON HOOK
;---------------------------------------------------------


BEGINNING_OF_HOOK:
			dc.b		"evHkShortCut"
old_event:		dc.l		0		


;-----First is the key checking-------------


	move.l	4(a7),a2
branch_opcode:
	bra.l		possibly_skip
possibly_skip:

;----Some code to skip if no flag was specified------

jump_start:
	lea		shift_indic(pc),a0
	cmp.w		#$710,(a2)			;is it command keypress?
	beq.s		check_on			;then we check if on is pressed
bit_test:
	btst.b	#0000,7(a2)			;so is shift being pressed?
	beq		no_shift
	st.b		(a0)				;signify that it was shift
	bra		call_next_hook
check_on:
	tst.b		(a0)				;so on was pressed but was shift pressed?
	beq		call_next_hook
jump_end:

	cmp.w		#$710,(a2)
	bne		call_next_hook
compare_opcode:
	cmp.w		#$1234,10(a2)			;see if it was the on key press
	bne		not_on_so_clear_shift


;-----Execute the program--------------------

	move.w	#$700,(a2)
	movem.l	d0-d7/a0-a6,-(a7)
	move.l	200,a6			;jump table
	move.l	600(a6),a5			;get dereference call
	pea		end_of_name(pc)		;need to find in the vat
	move.l	384(a6),a0			;get find call
	jsr		(a0)				;find it
	addq.l	#4,a7
continue_with_twin:
	tst.l		d0
	beq		not_found
	move.l	d0,-(a7)			;going to dereference this hsym
	move.l	484(a6),a0
	jsr		(a0)				;I now have a0 pointing to the vat entry
	move.w	$C(a0),d0			;get the handle of it
	btst.w	#9,$A(a0)			;is it archived?
	beq.S		already_in_ram

;----make a twin symbol------

	clr.l		-(a7)				;define it with the name so clear hsym part
	pea		end_of_name(pc)
	move.l	1432(a6),a0
	jsr		(a0)				;create the twin
	lea		12(a7),a7			;pop the parrameters and old hsym off the stack
	bra.S		continue_with_twin


;----Now execute it------


already_in_ram:
	move.w	d0,-(a7)			;place handle on the stack
	move.l	1060(a6),a4			;get pointer to top of estack pointer
	move.l	(a4),a3			;get top of the estack
	addq.l	#1,a3
	move.b	#$E5,(a3)			;place end estack tag
	move.l	a3,(a4)			;
	move.l	616(a6),a0			;get lock call
	jsr		(a0)				;lock it
	jsr		(a5)				;dereference it
	moveq		#0,d0
	move.w	(a0),d0			;get the size
	add.l		#$40000,a0			;point to ghost ram
	move.l	a0,a1
	add.l		d0,a0
	pea		1(a0)				;point to the tag
	pea		2(a1)				;place to relocate it to
	move.l	1384(a6),a0			;get the relocate call
	jsr		(a0)				;relocate it
	move.l	(a7)+,a0			;get place to jump to
	jsr		(a0)

;----Now for some undoing ----

	addq.l	#4,a7				;pop parammeters of the patch function off
	subq.l	#1,a3				;pop $E5 off of the estack
	move.l	a3,(a4)
	move.l	636(a6),a0			;unlock call
	jsr		(a0)				;unlock it
	move.w	#$760,(a2)			;make it comand paint
	move.l	(a6),a0			;get pointer to the first window pointer
	move.l	(a0),8(a2)			;get the first window pointer



no_free_ram:

	addq.l	#6,a7				;poop off the handle, variable, and hsym

not_found:
	movem.l	(a7)+,d0-d7/a0-a6
	

;-----Code to call the next hook-------------


not_on_so_clear_shift:
no_shift:
	lea		shift_indic(pc),a0
	clr.b		(a0)				;signify that there is no shift

call_next_hook:
	move.l	old_event(pc),a0		;get the old event handler
	move.l	a0,d0				;test it
	beq.S		no_old_hook
	move.l	a2,-(a7)			;input for the event handler
	jsr		(a0)				;call the next event handler
	addq.l	#4,a7				;pop it off
no_old_hook:
	rts


;----The variables----------------------------


shift_indic:	dc.b		0


			dc.b		0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 ;18 bytes
end_of_name:	dc.b		0

END_OF_HOOK:





 END
